/*global vars*/
var g_last_points = 0;
var g_point_unit = 1;
var g_upload_lmt = 1;
var g_download_lmt = 2;
var g_isLite = true;
var g_isLocked = false;
var g_isNormalMode = true;
var errLvlNeedPasscode = "5"
var g_isDisconnectAndLockedModalShown = false;
//存储从服务端发送过来的图片数据
var wsThumbnailData = null;
//websocket全局对象
var socket = null;
//uid for slideshow
var uid = "";
//report client status to server
var intervalId;
//websocket操作
var ws_Operation_Login            = "Login";
var ws_Operation_Logout           = "Logout";
var ws_Operation_Slideshow        = "Slideshow";
var ws_Operation_Heart            = "Heart";
var ws_Operation_Archive          = "Archive";
var ws_ss_Error                   = "Error";
var ws_ss_SeverPrepareForData     = "SeverPrepareForData";
var ws_ss_ServerIsReady           = "ServerIsReady";
var ws_ss_Processing              = "Processing";
var ws_ss_ServerStop              = "ServerStop";
var ws_ss_Status                  = "Status";
var ws_Operation_ServerStatus     = "ServerStatus"
var ws_Operation_ModeChanged      = "ModeChanged"
var ws_Operation_MediaAccountOverRun   = "MediaAccountOverRun"
var ws_Operation_IAPSuccess     = "IAPSuccess"

var app_ReloadPage_Saved  = 1;
var app_ReloadPage_Albums = 0;

$.blockUI.defaults.message = 'Please waiting...';
$.blockUI.defaults.css = {};
$.blockUI.defaults.baseZ = 20000;

var PAGE_ALLABLBUMS = "allAlbums";
var PAGE_SPECIFICALBUM = "specificAlbum";
var PAGE_ARCHIVES = "archives";

var errorMessage = "Sorry, system has a problem. Please check the network status.";

var DEFAULT_ALBUM = {
    "name" : "Default Album",
    "albumType" : "SavedPhotos",
    "editable" : false,
    "url" : "SYS_ALBUM_DEFAULT"
};

var app = {
    "currentPage" : "allAlbums",
    "currentAlbum" : DEFAULT_ALBUM
}

/*=========  Tool ========*/
function isFunction(fn) {
    return !!fn && !fn.nodeName && fn.constructor != String &&
        fn.constructor != RegExp && fn.constructor != Array &&
        /function/i.test( fn + "" );
}

function showNeedPasscodePrompt(isNeedPasscode)
{
    if(isNeedPasscode){
        $('.locker_tip').text("Your app is locked. You need unlock your app on your device.");
    }else{
        $('.locker_tip').text("Not connected. Please check network status.");
    }

    if(!g_isDisconnectAndLockedModalShown){
        g_isDisconnectAndLockedModalShown = true;
        $('#indexDropbox').empty();
        $('.count-title').text("");
        dismissPopWindow();
        $('#modal_locker').modal({
            backdrop:'static',
            keyboard:false,
            show:true
        });
    }
}

function isSafariOnWindowsOrIsIe(){
    var reg = /^safari$/i;
    var name = $.ua().browser.name;
    return $.ua().platform.isWindows && reg.test(name) || $.ua().isIe;
}

function dismissPopWindow()
{
    if(!$.ua().isIe || ($.ua().isIe && $.ua().ie > 8)){
        if(Lightview){
            try{
                //判断LightView是否显示在界面上,LightView不提供相应的API,只能手动判断lv_window.style是否包含block字符串,
                if($('.lv_window').attr("style").indexOf("block") != -1){
                    Lightview.hide();
                }
            }
            catch(ex){
                console.log(ex);
            }
        }
    }
    try{
        //无效果,模拟esc点击效果.
        var escEvt = $.Event("keypress", { keyCode: 27 });
        jQuery(this).trigger(escEvt);
    }
    catch(ex){
        console.log(ex);
    }

    $('#modal_serverInfo').modal('hide');
}

function showInfo(info,needClose,type,closeHandler){
    var alertContainer =  $(".alertInfo-container");
    alertContainer.empty();
    var alert = $('<div class="alert alert-block" id="alertInfo"></div>');

    if(arguments.length == 3){
        if(arguments[2] == "failure"){
            alert.addClass("alert-error");
        }else if(arguments[2] == "success"){
            alert.addClass("alert-info");
        }else{
            alert.addClass("alert-info");
        }
    }
    if(needClose){
        alert.html('<a class="close" data-dismiss="alert">&times;</a>'+info);
    }else{
        alert.html(info);
    }
    alert.appendTo(alertContainer);
    if (closeHandler) {
        alert.bind('closed', closeHandler);
    };
    if(!needClose){
        alert.delay(3000).fadeOut("normal",function(){
            alertContainer.empty();
        });
    }
}

function showIEAlert(){
    if($.browser.msie && !$.cookie('pt_ie_closed')){
        var info = "We don't support IE very well, please visit with other browser like Chrome/Safari/FireFox for best experience!";
        showInfo(info,true,"success",function(){
            $.cookie('pt_ie_closed', 'yes');
        });
    }
}

function getIndex(objs,obj){
    var idx = 0;
    for(var i = 0;i<objs.length;i++){
        if(objs[i].url == obj){
            idx = i+1;
            break;
        }
    }
    return idx;
}

function changeAssetUrl(str){
    //assets-library://asset/asset.JPG?id=6D6F447F-21BE-4989-8CA7-76C6D4CF96F9&ext=JPG
    //url=assets-library[((asset(asset{JPG?id=6D6F447F-21BE-4989-8CA7-76C6D4CF96F9&ext=JPG
    return str.replace(/\//g,"(").replace(":","[").replace(".","{").replace("?","&");
}

/*=========  App ========*/
function schemaIsReady(){
    showIEAlert();

    $(document).bind('dragenter', function (e) {
        if(!isSafariOnWindowsOrIsIe()){
            //IE or Safari on windows not support drag upload.
            $('#modal_dropZone').modal({
                backdrop:true,
                keyboard:false,
                show:true
            });

            if (app.currentAlbum.editable) {
                $('.destination_album_name').text(app.currentAlbum.name);
            }else{
                $('.destination_album_name').text("Default Album");
            }

            $('#modal_dropZone').on('dragenter', function (e) {
                $('#modal_dropZone').addClass('dragFileOver');
                console.log("dragFileOver");
            });
            $('#modal_dropZone').on('dragleave', function (e) {
                $('#modal_dropZone').removeClass('dragFileOver');
                console.log("dragFileOver dragleave");
            });
        }
    });
    $(document).bind('dragleave dragexit', function (e) {
        if(e.originalEvent.pageX == "0"){
            $('#modal_dropZone').modal('hide');
        }
    });

    $("#download_badge").hide();
    $('#download').tooltip({placement:'top',title:'Download as archive file'});
    var container = $("#indexDropbox");

    fileDrop(container,$('#modal_dropZone'));
    bindButtonAction(container);
    bindToolbar();

    bindWebsocket();
    //尝试新建websocket,如果浏览器支持websocket 则socket != null,不支持则socket == null;
    //如果socket != null,则获取配置数据和加载主页数据延迟到socket.onOpen事件中处理.
    //如果socket == null,则表示浏览器不支持websocket,为保证页面的基本功能,在此处则应进行配置数据和主页面的加载.
        if(socket == null){
        initConfigs();
        loadAlbums(container);
    }
}

function reloadPage(obj,mode){
    var iMode;
    if(arguments.length == 1){
        iMode = app_ReloadPage_Saved;
    }else{
        iMode = mode;
    }
    $('#modal_addAlbum').modal("hide");
    if(iMode == app_ReloadPage_Albums){
        //fake 与 非fake mode之间切换时.web界面跳回主界面;
        setPage(PAGE_ALLABLBUMS,DEFAULT_ALBUM);
    }
    if(app.currentPage == PAGE_ALLABLBUMS){
        $("#toolBar").hide();
        $(".big-title").text("Albums");
        window.document.title = "Albums";
        $('#modal_upload').modal("hide");
        loadAlbums(obj);
    }else if(app.currentPage == PAGE_SPECIFICALBUM){
        $("#toolBar").show();
        loadPhotos(obj);
    }else if(app.currentPage == PAGE_ARCHIVES){
        $("#download_badge").hide().parent().removeClass("light_badge");
        $("#toolBar").hide();
        $(".big-title").text("Archives");
        $(".count-title").text("Zip file that included your downloaded photos");
        loadZipList(obj);
    }
}

function bindButtonAction(obj){
    $("#refreshPage").click(function(e){
        e.preventDefault();
        reloadPage(obj);
    });
    $("#btnDownloadList").click(function(e){
        e.preventDefault();
        setPage(PAGE_ARCHIVES,DEFAULT_ALBUM);
        reloadPage(obj)
    });
//    $("#btnAdd").click(function(e){
//        e.preventDefault();
//        addAlbum(function(result){
//            $('#modal_addAlbum').modal("hide");
//            $(".count-title").show();
//            $("#toolBar").show();
//            loadPhotos(obj);
//        },function(){
//            $('#modal_addAlbum').modal("hide");
//        });
//    });
    $("#back").click(function(e){
        e.preventDefault();
        setPage(PAGE_ALLABLBUMS,DEFAULT_ALBUM);
        reloadPage(obj);
    });
}

function getAlbumName(){
    var name = null;
    var id = null;
    try{
        name = app.currentAlbum.name;
        id = app.currentAlbum.url;
        if(name == "undefined"){
            name = "Default Album";
            id = "SYS_ALBUM_DEFAULT";
        }
    }catch(err){
        name = "Default Album";
        id = "SYS_ALBUM_DEFAULT";
    }
    return {name:name,id:id};
}

function setPage(page,album){
    app.currentPage = page;
    app.currentAlbum = album;
}

function getServerInfo(success,failure){
    $.ajax({
        type:"post",
        url:"/tool/serverInfo",
        data:JSON.stringify({url:Math.uuid()}),
        dataType:"json",
        success:function(result){
            if(result.status == "1"){
                $.each(result.data,function(index,val){
                    if(isFunction(success)){
                        success(index,val);
                    }
                });
            }else{
                if(result.errLevel == "1"){
                    showInfo(result.desc,true,"failure");
                }
                if(result.errLevel == errLvlNeedPasscode){
                    showNeedPasscodePrompt(true);
                }
                if(isFunction(failure)){
                    failure();
                }
            }
        },
        error:function(result){
            showInfo(errorMessage,true,"failure");
            if(isFunction(failure)){
                failure();
            }
        }
    });
    return false;
}

function addAlbum(success,failure){
    $.blockUI();
    $.ajax({
        type:"post",
        url:"/album/addAlbum",
        data:JSON.stringify({name:$("#txtName").val()}),
        dataType:"json",
        success:function(result){
            $.unblockUI();
            if(result.status == "1"){
                app.currentAlbum = {
                    "name" : result.url,//result.url的值实际是name,不想改api了
                    "albumType" : result.data[0].albumType,
                    "editable" : true,
                    "url" : result.data[0].url
                };

                if(isFunction(success)){
                    showInfo(result.desc,false,"success");
                    success(result);
                }
            }else{
                if(result.errLevel == "1"){
                    showInfo(result.desc,true,"failure");
                }
                if(isFunction(failure)){
                    failure();
                }
            }
        },
        error:function(result){
            $.unblockUI();
            showInfo(errorMessage,true,"failure");
            if(isFunction(failure)){
                failure();
            }
        }
    });
}

function getConfigs(callback){
    $.ajax({
        type:"post",
        url:"/tool/getConfigs",
        data:JSON.stringify({url: Math.uuid()}),
        dataType:"json",
        success:function(result){
            if(result.status == "1"){
                if(isFunction(callback)){
                    callback({
                        status:true,
                        data:result.data
                    });
                }
            }
        },
        error:function(result){
            if(isFunction(callback)){
                callback({
                    status:false,
                    data:[]
                });
            }
        }
    });
}

function sendGift(callback){
    $.ajax({
        type:"post",
        url:"/tool/sendGift",
        data:JSON.stringify({url: Math.uuid()}),
        dataType:"json",
        success:function(result){
            if(result.status == "1"){
                showInfo(result.desc,true,"success");
            }else{
                if(result.errLevel == "1"){
                    showInfo(result.desc,true,"failure");
                }
            }
            if(isFunction(callback)){
                callback(result.data[0]);
            }
        },
        error:function(result){
            if(isFunction(callback)){
                callback({points:0,allPoints:0,unit:0});
            }
            showInfo(errorMessage,true,"failure");
        }
    });
}

function getSchema(success,failure){
    $.ajax({
        type:"post",
        url:"/tool/getSchema",
        data:JSON.stringify({url: Math.uuid()}),
        dataType:"json",
        success:function(result){
            if(result.status == "1"){
                $(result.data[0].content).prependTo($(document.body));
                if(isFunction(success)){
                    success(result.data[0].content);
                }
            }else{
                if(result.errLevel == "1"){
                    showInfo(result.desc,true,"failure");
                }
                if(isFunction(failure)){
                    failure(result);
                }
            }
        },
        error:function(result){
            if(isFunction(failure)){
                failure(result);
            }
            showInfo(errorMessage,true,"failure");
        }
    });
}

function initConfigs(){
    getConfigs(function(result){
        if(result.status){
            var tmp = result.data[0];
            if(tmp.type != "1"){
                //lite version
                g_upload_lmt = tmp.uploadLimit;
                g_download_lmt = tmp.downloadLimit;
                g_isLite = ((tmp.type == "0") ? true : false);
            }else{
                g_upload_lmt = Number.MAX_VALUE;
                g_download_lmt = Number.MAX_VALUE
                g_isLite = false;
            }
            g_isLocked = tmp.appLocked;

            if(g_isLite){
                $('#btnUpgradeToPro').attr('style','display:block;');
            }else{
                $('#btnUpgradeToPro').attr('style','display:none;');
            }
            if(g_isLocked){
                showNeedPasscodePrompt(true);
            }
            console.log(g_isLocked);
            console.log(g_upload_lmt);
            console.log(g_download_lmt);
            console.log(g_isLite);
        }
    });  
}

/*=========  upload ========*/
function canUpload(data,obj,type){
    //archives not support upload
    var bCanUpload = true;

    obj.removeClass('dragFileOver');
    obj.removeClass('documentOver');
    $('#modal_dropZone').modal('hide');

    if(app.currentPage == "archives" && type == 2){
        bCanUpload = false;
    }else{
        if(isSupportWebSocket() && g_isLocked){
            bCanUpload = false;
            showNeedPasscodePrompt(true);
        }else{
            //judge file type;
            var deletedArray = [];
            var acceptFileTypes = /(\.|\/)(gif|jpe?g|png|mov|mp4|m4v)$/i;
            for(var i = 0 ;i < data.files.length ;i++){
                if(!acceptFileTypes.test(data.files[i].name)){
                    deletedArray.push(i);
                }
            }
            try {
                for(var i = deletedArray.length - 1; i >=0; i--){
                    data.files.splice(deletedArray[i],1);
                }
            } catch (ex) {

            }
            
            if(data.files.length > g_upload_lmt && g_isLite){
                bCanUpload = false
                var info = "Lite version only supports upload " + g_upload_lmt + " photos once,you can upgrade to Pro version."
                showInfo(info,true,"failure");

            }else{
                if(data.files.length == 0){
                    bCanUpload = false
                    var info = "Nothing to be uploaded,just support gif,jpg/jpeg,png,mov,mp4,m4v files.";
                    showInfo(info,true,"failure");
                }else{
                    bCanUpload = true;
                }
            }
        }
    }
    return bCanUpload;
}

function createParams(){
    var tmp = getAlbumName();
    return { params:'name:'+encodeURI(tmp.name)+'|url:'+Math.uuid() +'|id:'+ tmp.id};
}

function fileDrop(obj,targetDropzone){
    $('#fileupload').fileupload({
        url:'asset/addAsset',
        dataType: 'json',
        sequentialUploads:true,
        dropZone:(isSafariOnWindowsOrIsIe() ? null:targetDropzone),
        //override add function
        add:function(e,data){
            data.formData = createParams();
            $.blueimp.fileupload.prototype.options.add.call(this, e, data);
        }
    });
    $('#fileupload').on("fileuploadchange",function(e,data){
        return canUpload(data,obj,1);
    });
    $('#fileupload').on("fileuploaddrop",function(e,data){
        return canUpload(data,obj,2);
    });
    $('#fileupload').on("fileuploadstart",function(e){
        $.blockUI();
    });
    $('#fileupload').on('fileuploadprogressall', function (e, data){
        var progress = parseInt(data.loaded / data.total * 100, 10);
        $('.blockMsg').text('Uploading...'+progress+'%');
    });
    $('#fileupload').on("fileuploadstop",function(e){
        $.unblockUI();
        reloadPage(obj);
    });
    $('#fileupload').on("fileuploadprocessalways",function(e,data){
        var file = data.files[data.index];
        if(file.error != undefined)
            showInfo(file.error,false,"failure");
    });

    $('#fileupload').on("fileuploadstart",function(e,data){
        targetDropzone.removeClass('documentOver');
        targetDropzone.removeClass('dragFileOver');
    });
}

/*=========  Albums ========*/
function loadAlbums(obj,cbSuccess,cbFailure){
    $("#toolBar").hide();
    obj.empty();
    $.blockUI();
    $.ajax({
        type:"post",
        url:"/internalAlbum/allAlbums",
        data:JSON.stringify({url:"ALL"}),
        dataType:"json",
        success:function(result){
            if(result.status == "1"){
                obj.addClass('index_page').removeClass('album_page');
                var container = $('<ul class="thumbnails" id="albums"></ul>');
                $('.count-title').text(result.quantity+" Albums");
                $.each(result.data,function(index,val){
                    var imgSrc = '/albums/thumbnails/'+val.url;
                    $('<li class="album_warp">'+
                        '<a href="#" n='+encodeURI(val.name)+' u='+encodeURI(val.url)+' albumType="'+val.albumType+'" editable="'+val.editable+'" class="thumbnail thumbnailAlbum">'+
                        '<img src='+imgSrc+' class="album_image">'+
                        '<h5 class="album_title">'+val.name+'</h5>'+
                        '<p class="album_desc '+val.albumType+'">'+val.amount+' Photos</p>'+
                        '</a>'+
                        '</li>').appendTo(container);
                });
                container.appendTo(obj);
                
//                setUpUseGuide();
                $("a.thumbnailAlbum").click(function(e){
                    e.preventDefault();
                    var name = decodeURI($(this).attr("n"));
                    var url = decodeURI($(this).attr("u"));
                    var albumType = $(this).attr("albumType");
                    var editable = $(this).attr("editable") === "true" ? true : false;
                    $("#toolBar").show();
                    $(".count-title").show();
                    resetEditButton();
                    setPage(PAGE_SPECIFICALBUM,{
                        "name" : name,
                        "albumType" : albumType,
                        "editable" : editable,
                        "url" : url
                    });
                    loadPhotos(obj);
                });

                if(isFunction(cbSuccess)){
                    cbSuccess();
                }
            }else{
                if(result.errLevel == "1"){
                    showInfo(result.desc,true,"failure");
                }
                if(result.errLevel == errLvlNeedPasscode){
                    showNeedPasscodePrompt(true);
                }
                if(isFunction(cbFailure)){
                    cbFailure();
                }
            }
            $.unblockUI();
        },
        error:function(result){
            $.unblockUI();
            showInfo(errorMessage,true,"failure");
            if(isFunction(cbFailure)){
                cbFailure();
            }
        }
    });
}

function setUpUseGuide(){
    if(!$.cookie('pt_guide_finished')){
        var trip = new Trip([{ 
            sel : $('#btnUpload'),
            // expose : true,
            content : 'Click this button to upload your photos and videos',
            position:'s',
            callback:function(){
                $('#modal_dropZone').modal({
                    backdrop:true,
                    keyboard:false,
                    show:true
                });
            }
        },{
            sel : $('#modal_dropZone'),
            content : 'Drag your photos from PC/Mac here to upload<br/>(Only show when you drag photos in web browser)',
            // expose : true,
            position:'n',
            callback:function(){
                $('#modal_dropZone').modal('hide');
            }
        },{
           sel : $('#albums'),
           content : 'All of your albums and photos list in this area, enjoy it!',
           // expose : true,
           position:'s',
           showCloseBox : false
        }],{
            tripTheme:'white',
            delay : -1,
            showNavigation : true,
            canGoPrev : false,
            finishLabel : 'Close',
            onTripEnd:function(){
                $.cookie('pt_guide_finished', 'yes');
            }
        }); 
        trip.start();
    } 
}

/*=========  Archives ========*/
function loadZipList(obj,cbSuccess,cbFailure){
    obj.empty();
    $.blockUI();
    $.ajax({
        type:"post",
        url:"/tool/downloadList",
        data:JSON.stringify({url: Math.uuid()}),
        dataType:"json",
        success:function(result){
            if(result.status == "1"){
                obj.addClass('index_page').removeClass('album_page');
                var sContainer = '<div class="row"><div class="span10 offset1"><table class="table table-bordered table-striped">'+
                    '<thead>'+
                    '<tr>'+
                    '<th>Name</th>'+
                    '<th>Amount</th>'+
                    '<th>Size</th>'+
                    '<th>CreateDate</th>'+
                    '<th></th>'+
                    '<th></th>'+
                    '</tr>'+
                    '</thead>'+
                    '<tbody id="tableBody"></tbody>'+
                    '</table></div></div>';

                $(sContainer).appendTo(obj);
                var re = /^\s*\(.+PhotoTransfer\s*\)\s*$/;
                var data = result.data;
                data.sort(function(a,b){
                    return a.date < b.date;
                });
                $.each(result.data,function(index,val){
                    if(val.name.match(re)){
                        $("<tr><td>zip archive</td><td>0</td><td>"+val.size+"</td><td>"+val.date+"</td>"+
                            "<td>Processing</td><td></td>"+
                            "</tr>").appendTo($("#tableBody"));
                    }else{
                        $("<tr><td>"+val.name+"</td><td>"+val.amount+"</td><td>"+val.size+"</td><td>"+val.date+"</td>"+
                            "<td><a href='/zip/"+val.name+"' class='btn-link'>Download</a></td>"+
                            "<td><a href='#' onclick='delZip(this);' name='"+val.name+"'class='btn-link'>Delete</a></td>"+
                            "</tr>").appendTo($("#tableBody"));
                    }
                });
                if(isFunction(cbSuccess)){
                    cbSuccess();
                }
            }else{
                if(result.errLevel == "1"){
                    showInfo(result.desc,true,"failure");
                }
                if(result.errLevel == errLvlNeedPasscode){
                    showNeedPasscodePrompt(true);
                }
                if(isFunction(cbSuccess)){
                    cbFailure();
                }
            }
            $.unblockUI();
        },
        error:function(result){
            $.unblockUI();
            showInfo(errorMessage,true,"failure");
            if(isFunction(cbSuccess)){
                cbFailure();
            }
        }
    });
}

function delZip(obj){
    $.blockUI();
    $.ajax({
        type:"post",
        url:"/tool/deleteZip",
        data:JSON.stringify({url: Math.uuid(),name:obj.name}),
        dataType:"json",
        success:function(result){
            if(result.status == "1"){
                loadZipList($("#indexDropbox"));
            }else{
                if(result.errLevel == "1"){
                    showInfo(result.desc,true,"failure");
                }
                if(result.errLevel == errLvlNeedPasscode){
                    showNeedPasscodePrompt(true);
                }
            }
            $.unblockUI();
        },
        error:function(result){
            $.unblockUI();
            showInfo(errorMessage,true,"failure");
        }
    });
    return false;
}

/*=========  Photos ========*/
function loadPhotos(o,cbSuccess,cbFailure){
    o.empty();
    $.blockUI();
    $.ajax({
        type:"post",
        url:"/internalAlbum/specificAlbums",
        data:JSON.stringify({url: app.currentAlbum.url}),
        dataType:"json",
        success:function(result){
            if(result.status == "1"){
                $('.big-title').text(app.currentAlbum.name);
                $('.count-title').text(result.quantity+" Photos");
                o.addClass('album_page').removeClass('index_page');
                window.document.title = app.currentAlbum.name;
                if(result.data.length >0){
                    var container =$('<ul id="albums" class="thumbnails"></ul>');
                    $.each(result.data,function(index,val){
                        var serialNumber = index + 1;

                        var itemUrl = '';
                        var overlayInnerHtml = '<img src="/images/zoomout_icon.png" class="zoomout_icon" title="origin photo"/>';
                        var directDownloadHtml = '<div class="btn btn-mini directDownload" title="Download photo">Download</div>';

                        var inner_icons = ' ';
                        if (val.type == "0") {//if is photo
                            itemUrl = "/origins/" + val.url;
                        }else{
                            itemUrl = "/origins/" + val.url;
                            inner_icons = '<img src="/images/play_icon.png" class="play_icon"/>';
                        }
                        var html = '<li class="span2 thumbnail_warp">'+
                            '<div class="thumbnail_image"><a href="'+itemUrl+'" class="thumbnail" w='+val.width+' h='+val.height+' t='+val.type+' u='+val.url+'>'+
                            '<img src="./images/grey.gif" data-original="/photos/thumbnails/' + val.url+'" class="photo_image">'+
                            '<div class="inner_icons">'+ inner_icons +'</div>'+
                            '</a>';
                        html +=  '<div class="thumbnail_overlay">'+ overlayInnerHtml +'</div></div>'+
                                '<div class="photo-edit-bar"><label class="checkbox inline">'+serialNumber +
                                '<input id="'+serialNumber+'" type="checkbox" name="'+val.type+'" value="'+val.url+'">'+
                                '</label>'+
                                directDownloadHtml +
                                '</div></li>';
                        $(html).appendTo(container);
                        $(".thumbnail_image").hover(
                            function () {
                                $(this).children('.thumbnail_overlay').children('.zoomout_icon').show();
                            },
                            function () {
                                $(this).children('.thumbnail_overlay').children('.zoomout_icon').hide();
                            }
                        );
                        $(".photo-edit-bar").hide();
                        $(".zoomout_icon").hide();
                    });
                    container.appendTo(o);
                    $(".zoomout_icon").click(function(e){
                        e.preventDefault();
                        var url = $(this).parent().siblings('.thumbnail').attr('href');
                        window.open(url);
                    });
                    $(".directDownload").click(function(e){
                        e.preventDefault();
                        var url = "directDownload/" + $(this).parent().siblings('.thumbnail_image').children('.thumbnail').attr('u');
                        window.open(url);
                    });
                }else{
                    //空album,添加用户操作引导
                    var container =$('<div class="userGuide"><img src="/images/emptyAlbumGuide.png" /><h5 class="muted">Drag photos/videos here to upload</h5></div>');
                    container.appendTo(o);
                }

                $(":checkbox").change(function(){
                    if($(this).prop("checked")== true){
                        $(this).parent().parent().siblings('.thumbnail_image').children('.thumbnail').addClass('photo-checked');
                    }else{
                        $(this).parent().parent().siblings('.thumbnail_image').children('.thumbnail').removeClass('photo-checked');
                    }
                    updateAmountOfSelected();
                    enableDownloadBtn();
                });
//                initDropdownLstMenu($("#copyToMenu"));
                resetEditButton();
                bindLightview();
                enableDownloadBtn();
                $("img.photo_image").lazyload({
                    failure_limit : 2
                });

                if(isFunction(cbSuccess)){
                    cbSuccess(result);
                }
                $.unblockUI();
            }else{
                $.unblockUI();
                if(result.errLevel == "1"){
                    showInfo(result.desc,true,"failure");
                }
                if(result.errLevel == errLvlNeedPasscode){
                    showNeedPasscodePrompt(true);
                }
                if(isFunction(cbSuccess)){
                    cbFailure(result);
                }
            }
        },
        error:function(result){
            $.unblockUI();
            showInfo(errorMessage,true,"failure");
            if(isFunction(cbSuccess)){
                cbFailure(result);
            }
        }
    });
}

function updateAmountOfSelected(){
    var amount = $(":checkbox[checked]").length;
    var text = null;
    var textMoveTo = null;
    if(amount != 0){
        text = "Download (" + amount + ")";
        textMoveTo = "Copy to (" + amount + ")";
    }else{
        text = "Download";
        textMoveTo = "Copy to";
    }
    $("#download").text(text).prepend('<i class="icon-arrow-down icon-white"></i> ');
//    $("#copyTo").html(textMoveTo+' <span class="caret"></span>');
}

function resetEditButton(){
    $("#edit").text("Edit").prepend('<i class="icon-edit icon-white"></i> ');
    $(".thumbnail,.play_icon").unbind("click");
    $(":checkbox").attr("checked",false);
    $(".thumbnail").removeClass("photo-checked");
//    $("#editGrp,#download,#copyTo").hide();
    $("#editGrp,#download").hide();
    $("#albums .photo-edit-bar").hide();
}

function bindToolbar(){
    $("#download").unbind("click");
    $("#download").click(function(e){
        e.preventDefault();
        batchDownload($(":checkbox[checked]"),function(){
            resetEditButton();
        },function(){
            resetEditButton();
        });
    });

    $("#select").unbind("click");
    $("#select").click(function(e){
        $(":checkbox").attr("checked",true);
        $(".thumbnail").addClass("photo-checked");
        enableDownloadBtn();
        updateAmountOfSelected();
    });

    $("#unselect").unbind("click");
    $("#unselect").click(function(e){
        $(":checkbox").attr("checked",false);
        $(".thumbnail").removeClass("photo-checked");
        enableDownloadBtn();
        updateAmountOfSelected();
    });

    $("#edit").unbind("click");
    $("#edit").click(function(e){
        if ($("#edit").text().indexOf("Edit")>0) {
            $(this).text("Done").prepend('<i class="icon-ok icon-white"></i> ');
//            $("#editGrp,#download,#copyTo").show();
            $("#editGrp,#download").show();

            $("#albums .photo-edit-bar").show();
            unbindLightview();
            $(".thumbnail").toggle(function(e){
                e.preventDefault();
                $(this).addClass("photo-checked");
                $(this).parent().siblings(".photo-edit-bar").children("label").children(":checkbox").attr("checked",true);
                enableDownloadBtn();
                updateAmountOfSelected();
            },function(e){
                e.preventDefault();
                $(this).removeClass("photo-checked");
                $(this).parent().siblings(".photo-edit-bar").children("label").children(":checkbox").attr("checked",false);
                enableDownloadBtn();
                updateAmountOfSelected();
            });
        }else{
            e.preventDefault();
            resetEditButton();
            bindLightview();
            updateAmountOfSelected();

        }
    }); 
}

function initDropdownLstMenu(obj,cbSuccess,cbFailure){
    obj.empty();
    $.ajax({
        type:"post",
        url:"/album/allAlbums",
        data:JSON.stringify({url:"ALL"}),
        dataType:"json",
        success:function(result){
            if(result.status == "1"){
                $.each(result.data,function(index,val){
                    var albumName = decodeURI(val.name);
                    var editable = val.editable;
                    if(albumName !== app.currentAlbum.name){
                        $('<li class="'+(editable?"":"disabled")+'"><a class="dropdownListMenu" href="#" n="'+decodeURI(val.name)+'" u="'+decodeURI(val.url)+'"</a>'+decodeURI(val.name)+'</li>').appendTo(obj);
                    }
                });
                $(".dropdownListMenu").unbind("click");
                $(".dropdownListMenu").bind("click",function(e){
                    e.preventDefault();
                    copyTo($(":checkbox[checked]"),app.currentAlbum.url,app.currentAlbum.name,$(this).attr("u"),$(this).attr("n"),function(){
                        resetEditButton();
                    },function(){
                        resetEditButton();
                    });
                });

                if(isFunction(cbSuccess)){
                    cbSuccess(result);
                }
            }else{
                if(isFunction(cbFailure)){
                    cbFailure();
                }
            }
        },
        error:function(result){
            if(isFunction(cbFailure)){
                cbFailure();
            }
        }
    });
}

function batchDownload(oImages,cbSuccess,cbFiilure){
    $.blockUI();
    var objs = [];
    $.each(oImages,function(idx,val){
        objs[idx]={url:val.value,type:val.name};
    });
    var req ={
        url:Math.uuid(),
        quantity:oImages.length,
        data: objs
    };
    $.ajax({
        type:"post",
        url:"asset/batchGetAsset",
        data:JSON.stringify(req),
        dataType:"json",
        success:function(result){
            $.unblockUI();
            if(result.status == "1"){

                var downloadTrip = new Trip([{ 
                    sel : $('#btnDownloadList'),
                    content : 'All of photos your just download would <br/>packaged in a zip file, click this to check',
                    position:'s'
                }],{
                    tripTheme:'white',
                    delay : 10000
                }); 
                downloadTrip.start();

                showInfo(result.desc,false,"success");
            }else{
                if(result.errLevel == "1"){
                    showInfo(result.desc,true,"failure");
                }
                if(result.errLevel == errLvlNeedPasscode){
                    showNeedPasscodePrompt(true);
                }
            }
            if(isFunction(cbSuccess)){
                cbSuccess();
            }
        },
        error:function(result){
            $.unblockUI();
            showInfo(errorMessage,true,"failure");
            if(isFunction(cbFiilure)){
                cbFiilure();
            }
        }
    });
}

function copyTo(oImages,from,fromName,to,toName,cbSuccess,cbFailure){
    $.blockUI();
    var entities = [];
    $.each(oImages,function(idx,val){
        entities[idx]=val.value;
    });
    var req ={
        url:Math.uuid(),
        entities: entities,
        from:from,
        fromName:fromName,
        to:to,
        toName:toName
    };
    $.ajax({
        type:"post",
        url:"asset/copyTo",
        data:JSON.stringify(req),
        dataType:"json",
        success:function(result){
            $.unblockUI();
            if(result.status == "1"){
                showInfo(result.desc,false,"success");
            }else{
                if(result.errLevel == "1"){
                    showInfo(result.desc,true,"failure");
                }
            }
            if(isFunction(cbSuccess)){
                cbSuccess();
            }
        },
        error:function(result){
            $.unblockUI();
            showInfo(errorMessage,true,"failure");
            if(isFunction(cbFailure)){
                cbFailure();
            }
        }
    });
}

function enableDownloadBtn(){
    if($(":checkbox:checked").length == 0){
        $("#download").attr("disabled","disabled");
//        $("#copyTo").attr("disabled","disabled");
    }
    if($(":checkbox:checked").length > 0 ){
        if(g_isLite && $(":checkbox:checked").length > 1){
            showInfo("Lite version not supports Batch download,you can upgrade to Pro version.",true,"failure");
        }
        $("#download").removeAttr("disabled");
//        $("#copyTo").removeAttr("disabled","disabled");
    }
    if(g_isLite){
        $("#download").attr("disabled","disabled");
    }
}

function bindLightview(){
    if($.ua().isIe && $.ua().ie < 9){
        $(".thumbnail,.play_icon").bind("click",function(e){
            e.preventDefault();
            var this_href = $(this).attr("href") || $(this).parent().siblings('.thumbnail').attr("href");
            window.open(this_href);
        });
    }else{
        var objs = $(".thumbnail");
        var hrefs=[];
        objs.each(function(idx,val){
            if($(val).attr("t") == "1"){
                //video
                hrefs.push({
                    url:$(val).attr("href"),
                    options:{
                        height: parseInt($(val).attr("h")),
                        width: parseInt($(val).attr("w"))
                    }
                });
            }else{
                hrefs.push({url:$(val).attr("href")});
            }
        });
        Lightview.setDefaultSkin('mac');
        $(".thumbnail,.play_icon").bind("click",function(e){
            e.preventDefault();
            //如果是从播放按钮点击则查找对应的thumbnail
            var this_href = $(this).attr("href") || $(this).parent().siblings('.thumbnail').attr("href");
            var idx = getIndex(hrefs,this_href);
            Lightview.show(hrefs,{slideshow:3000,preload:false},idx);
        });
    }
}

function unbindLightview(){
    $(".thumbnail,.play_icon").unbind("click");
}

/*=========  Web Socket ========*/
function PTWebsocket(){
    var ws = null;
    if ("WebSocket" in window){
        try{
            ws = new ReconnectingWebSocket("%%WEBSOCKET_URL%%");
        }catch(ex){
            ws = null;
        }
    }
    return ws;
}

function isSupportWebSocket(){
    return PTWebsocket() == null ? false : true;
}

function loadSlideshowData(o,result){
    o.empty();
    $.blockUI();
    var data =[];
    var container =$('<ul id="albums" class="thumbnails"></ul>');
    container.appendTo(o);

    $('.big-title').text("Slide show");
    $('.count-title').text(result.quantity+" Photos");
    $.each(result.data,function(index,val){
        var itemUrl = '';
        var inner_icons = ' ';
        if (val.type == "0") {//if is photo
            itemUrl = "/origins/"+val.thumbnail+"?url="+changeAssetUrl(val.url);
        }else{
            itemUrl = "/origins/"+val.thumbnail.split('.')[0]+'.mov?url='+changeAssetUrl(val.url);
            inner_icons = '<img src="/images/play_icon.png" class="play_icon"/>';
        }
        if(val.type == "1"){
            //video
            data.push({
                url:itemUrl,
                options:{
                    height: parseInt(val.height),
                    width: parseInt(val.width)
                }
            });
        }else{
            data.push({url:itemUrl});
        }
        var html = '<li class="span2 thumbnail_warp">'+
            '<a href="/origins/'+itemUrl+'" class="thumbnail" w='+val.width+' h='+val.height+' t='+val.type+'>'+
            '<img src="./images/grey.gif" data-original="/thumbnails/'+val.thumbnail+'" class="photo_image">'+
            '<div class="inner_icons">'+ inner_icons +'</div>'+
            '</a></li>';
        $(html).appendTo(container);
    });
    $("img.photo_image,.inner_icons").click(function(e){
        e.preventDefault();
    });
    $("img.photo_image").lazyload({
        failure_limit : 2
    });
    $.unblockUI();
    return data;
}

function bindWebsocket(){
    socket = PTWebsocket();
    if(socket == null){return;}
    socket.onopen = function(evt){wsOnOpen(evt);};
    socket.onmessage = function(evt){wsOnMessage(evt);};
    socket.onclose = function(evt){wsOnClose(evt);};
    socket.onerror = function(err){wsOnError(err);};
    socket.onconnecting = function(evt){wsOnConnecting(evt);};
    window.onbeforeunload = function(){
        if(socket){
            //do something when browser will be refreshed or closed;
            if(wsThumbnailData){
                wsThumbnailData = null;
            }
            sendWsCommand({
                Category:ws_Operation_Logout,
                Uid:uid
            });
            clearInterval(intervalId);
            clearWsInstance();
        }
    };
}

function wsOnConnecting(evt){
    console.log("wsOnConnecting");
}
function wsOnOpen(evt){
    uid = Math.uuid();
    sendWsCommand({
        Category:ws_Operation_Login,
        Uid:uid
    });
    intervalId = setInterval(heart,30000);
    g_isDisconnectAndLockedModalShown = false;
    $(".alertInfo-container").empty();
    $('#modal_locker').modal('hide');

    //websocket连接成功后向服务器请求配置参数,并加载主页.
    initConfigs();
    reloadPage($("#indexDropbox"),app_ReloadPage_Albums);
}

function wsOnMessage(evt){
    actionByWsCommand(evt);
}

function wsOnClose(evt){
    clearInterval(intervalId);
    showNeedPasscodePrompt(false);
}

function wsOnError(evt){
    clearInterval(intervalId);
    showNeedPasscodePrompt(false);
}

function actionByWsCommand(evt){
    var json = JSON.parse(evt.data);
    var category = json.Category;
    switch (category){
        case ws_Operation_Slideshow:
            var action = json.Action;
            if(action == ws_ss_SeverPrepareForData){
                if(Lightview){
                    if($('.lv_window').attr("style").indexOf("block") != -1){
                        Lightview.hide();
                    }                }
                $.blockUI({ message:json.desc });
                wsThumbnailData = null;
            }
            if(action ==ws_ss_Error){
                $.unblockUI();
                showInfo(json.desc,true,"failure");
                wsThumbnailData = null;
            }
            if(action == ws_ss_ServerIsReady){
                $.unblockUI();
                $('.remote_mode').show();
                wsThumbnailData = loadSlideshowData($("#indexDropbox"),json);
            }
            if(action == ws_ss_Processing){
                var current = parseInt(json.next);
                if(current >= 0){
                    Lightview.show(wsThumbnailData[current],{
                        controls:{
                            close: false
                        },
                        preload:false,
                        slideshow: false,
                        keyboard: false,
                        mousewheel: false,
                        overlay: {
                            close: false,
                            background: '#202020',
                            opacity: .85
                        },
                        skin: 'dark'
                    });
                    sendWsCommand({
                        Category:ws_Operation_Slideshow,
                        Uid:uid,
                        Action:ws_ss_Status
                    });
                }
            }
            if(action == ws_ss_ServerStop){
                if(Lightview){
                    if($('.lv_window').attr("style").indexOf("block") != -1){
                        Lightview.hide();
                    }
                }
                wsThumbnailData = null;
                //返回原来操作
                $('.remote_mode').hide();
                reloadPage($("#indexDropbox"));
            }
            break;
        case ws_Operation_Archive:
            $("#download_badge").show().parent().addClass("light_badge");
            break;
        case ws_Operation_Heart:
//            g_isLocked = (json.status == "1" ? true:false);
//            console.log(g_isLocked);
               break;
        case ws_Operation_ServerStatus:
            var old = g_isLocked;

            g_isLocked = (json.status == "1" ? true:false);

            if(old == true && g_isLocked == false ){
                //app没有锁定
                $('#modal_locker').modal('hide');
                g_isDisconnectAndLockedModalShown = false;
            }else if (g_isLocked) {
                //app已经锁定
                showNeedPasscodePrompt(true);
            }
            break;
        case ws_Operation_ModeChanged:
            var oldMode = g_isNormalMode;
            $('#indexDropbox').empty();
            g_isNormalMode = (json.isNormalMode == 1 ? false:true);
            if(oldMode == g_isNormalMode){
                //app没有切换browserType,重新加载上一次浏览的页面
                reloadPage($("#indexDropbox"),app_ReloadPage_Saved);
            }else{
                //app切换browserType,加载主页即Albums页面
                reloadPage($("#indexDropbox"),app_ReloadPage_Albums);
            }
            break;
        case ws_Operation_MediaAccountOverRun:
            showInfo("Lite version has amount limit,you can upgrade to Pro version.",true,"failure");
            break;
        default:
        case ws_Operation_IAPSuccess:
            initConfigs();
            break;
    }
}

function heart(){
    if(socket){
        sendWsCommand({
            Category:ws_Operation_Heart,
            Uid:uid
        });
    }
}

function clearWsInstance(){
    uid = null;

    socket.close();
    socket = null;
    if(wsThumbnailData){
        wsThumbnailData = null;
    }
}

function sendWsCommand(obj){
    if(socket){
        var cmd = {};
        for (property in obj){
            cmd[property.toString()] = obj[property];
        }
        socket.send(JSON.stringify(cmd));
    }
}
